Index: trunk/LMDZ.MARS/libf/phymars/writediagfi.F
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/writediagfi.F	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/writediagfi.F	(revision 1130)
@@ -40,4 +40,8 @@
 !=================================================================
       use surfdat_h, only: phisfi
+      use control_mod, only: ecritphy, day_step, iphysiq
+      USE mod_phys_lmdz_para, only : is_parallel, is_mpi_root,
+     &                               is_master, gather
+      USE mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
       implicit none
 
@@ -46,5 +50,5 @@
 !#include "dimphys.h"
 #include "paramet.h"
-#include "control.h"
+!#include "control.h"
 #include "comvert.h"
 #include "comgeom.h"
@@ -97,4 +101,19 @@
       
 #ifndef MESOSCALE
+
+#ifdef CPP_PARA
+! Added to work in parallel mode
+      real dx3_glop(klon_glo,llm)
+      real dx3_glo(iim,jjp1,llm) ! to store a global 3D data set
+      real dx2_glop(klon_glo)
+      real dx2_glo(iim,jjp1)     ! to store a global 2D (surface) data set
+      real px2(ngrid)
+!      real dx1_glo(llm)          ! to store a 1D (column) data set
+!      real dx0_glo
+      real phisfi_glo(klon_glo) ! surface geopotential on global physics grid
+#else
+      real phisfi_glo(ngrid) ! surface geopotential on global physics grid
+#endif
+
 !***************************************************************
 !Sortie des variables au rythme voulu
@@ -162,7 +181,21 @@
            stop
          endif
+         
+         zitau = -1 ! initialize zitau
+
+#ifdef CPP_PARA
+          ! Gather phisfi() geopotential on physics grid
+          call Gather(phisfi,phisfi_glo)
+#else
+         phisfi_glo(:)=phisfi(:)
+#endif
+
+         !! parallel: we cannot use the usual writediagfi method
+!!         call iophys_ini
+         if (is_master) then
+         ! only the master is required to do this
 
          ! Create the NetCDF file
-         ierr = NF_CREATE(fichnom, IOR(NF_CLOBBER,NF_64BIT_OFFSET), nid)
+         ierr = NF_CREATE(fichnom, NF_CLOBBER, nid)
          ! Define the 'Time' dimension
          ierr = nf_def_dim(nid,"Time",NF_UNLIMITED,idim)
@@ -183,11 +216,18 @@
 
          ! write "header" of file (longitudes, latitudes, geopotential, ...)
-         call gr_fi_dyn(1,ngrid,iip1,jjp1,phisfi,phis)
+         call gr_fi_dyn(1,size(phisfi_glo),iip1,jjp1,phisfi_glo,phis)
          call iniwrite(nid,day_ini,phis)
-         
-         zitau = -1 ! initialize zitau
+
+         endif ! of if (is_master)
+
       else
-         ! Open the NetCDF file
-         ierr = NF_OPEN(fichnom,NF_WRITE,nid)
+
+         if (is_master) then
+           ! only the master is required to do this
+
+           ! Open the NetCDF file
+           ierr = NF_OPEN(fichnom,NF_WRITE,nid)
+         endif ! of if (is_master)
+
       endif ! if (firstnom.eq.'1234567890')
 
@@ -218,4 +258,6 @@
 !--------------------------------------------------------
 
+        if (is_master) then
+           ! only the master is required to do this
         if (nom.eq.firstnom) then
         ! We have identified a "first call" (at given date)
@@ -241,8 +283,23 @@
         end if ! of if (nom.eq.firstnom)
 
+        endif ! of if (is_master)
+
 !Case of a 3D variable
 !---------------------
         if (dim.eq.3) then
 
+#ifdef CPP_PARA
+          ! Gather field on a "global" (without redundant longitude) array
+          call Gather(px,dx3_glop)
+!$OMP MASTER
+          if (is_mpi_root) then
+            call Grid1Dto2D_glo(dx3_glop,dx3_glo)
+            ! copy dx3_glo() to dx3(:) and add redundant longitude
+            dx3(1:iim,:,:)=dx3_glo(1:iim,:,:)
+            dx3(iip1,:,:)=dx3(1,:,:)
+          endif
+!$OMP END MASTER
+!$OMP BARRIER
+#else
 !         Passage variable physique -->  variable dynamique
 !         recast (copy) variable from physics grid to dynamics grid
@@ -260,9 +317,9 @@
              ENDDO
            ENDDO
-
+#endif
 !         Ecriture du champs
 
-!         write (*,*) 'In  writediagfi, on sauve:  ' , nom
-!         write (*,*) 'In  writediagfi. Estimated date = ' ,date
+          if (is_master) then
+           ! only the master writes to output
 ! name of the variable
            ierr= NF_INQ_VARID(nid,nom,varid)
@@ -294,4 +351,8 @@
 !           ierr= NF_PUT_VARA_DOUBLE(nid,varid,corner,edges,dx3)
 !#else
+!           write(*,*)"test:  nid=",nid," varid=",varid
+!           write(*,*)"       corner()=",corner
+!           write(*,*)"       edges()=",edges
+!           write(*,*)"       dx3()=",dx3
            ierr= NF_PUT_VARA_REAL(nid,varid,corner,edges,dx3)
 !#endif
@@ -300,12 +361,29 @@
               write(*,*) "***** PUT_VAR problem in writediagfi"
               write(*,*) "***** with ",nom
-              write(*,*) 'ierr=', ierr
+              write(*,*) 'ierr=', ierr,": ",NF_STRERROR(ierr)
 c             call abort
            endif 
 
+          endif !of if (is_master)
+
 !Case of a 2D variable
 !---------------------
 
         else if (dim.eq.2) then
+
+#ifdef CPP_PARA
+          ! Gather field on a "global" (without redundant longitude) array
+          px2(:)=px(:,1)
+          call Gather(px2,dx2_glop)
+!$OMP MASTER
+          if (is_mpi_root) then
+            call Grid1Dto2D_glo(dx2_glop,dx2_glo)
+            ! copy dx2_glo() to dx2(:) and add redundant longitude
+            dx2(1:iim,:)=dx2_glo(1:iim,:)
+            dx2(iip1,:)=dx2(1,:)
+          endif
+!$OMP END MASTER
+!$OMP BARRIER
+#else
 
 !         Passage variable physique -->  physique dynamique
@@ -323,5 +401,8 @@
                 dx2(iip1,j)=dx2(1,j)
              ENDDO
-
+#endif
+
+          if (is_master) then
+           ! only the master writes to output
 !         write (*,*) 'In  writediagfi, on sauve:  ' , nom
 !         write (*,*) 'In  writediagfi. Estimated date = ' ,date
@@ -359,12 +440,19 @@
               write(*,*) "***** PUT_VAR matter in writediagfi"
               write(*,*) "***** with ",nom
-              write(*,*) 'ierr=', ierr
+              write(*,*) 'ierr=', ierr,": ",NF_STRERROR(ierr)
 c             call abort
            endif 
 
+          endif !of if (is_master)
+
 !Case of a 1D variable (ie: a column)
 !---------------------------------------------------
 
        else if (dim.eq.1) then
+         if (is_parallel) then
+           write(*,*) "writediagfi error: dim=1 not implemented ",
+     &                 "in parallel mode"
+           stop
+         endif
 !         Passage variable physique -->  physique dynamique
 !         recast (copy) variable from physics grid to dynamics grid
@@ -402,5 +490,5 @@
               write(*,*) "***** PUT_VAR problem in writediagfi"
               write(*,*) "***** with ",nom
-              write(*,*) 'ierr=', ierr
+              write(*,*) 'ierr=', ierr,": ",NF_STRERROR(ierr)
 c             call abort
            endif 
@@ -410,6 +498,9 @@
 
         else if (dim.eq.0) then
+
            dx0 = px (1,1)
 
+          if (is_master) then
+           ! only the master writes to output
            ierr= NF_INQ_VARID(nid,nom,varid)
            if (ierr /= NF_NOERR) then
@@ -437,13 +528,17 @@
               write(*,*) "***** PUT_VAR matter in writediagfi"
               write(*,*) "***** with ",nom
-              write(*,*) 'ierr=', ierr
+              write(*,*) 'ierr=', ierr,": ",NF_STRERROR(ierr)
 c             call abort
            endif 
 
+          endif !of if (is_master)
+
         endif ! of if (dim.eq.3) elseif(dim.eq.2)...
 
       endif ! of if ( MOD(zitau+1,irythme) .eq.0.)
 
-      ierr= NF_CLOSE(nid)
+      if (is_master) then
+        ierr= NF_CLOSE(nid)
+      endif
 
 #endif
Index: trunk/LMDZ.MARS/libf/phymars/writediagsoil.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/writediagsoil.F90	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/writediagsoil.F90	(revision 1130)
@@ -13,4 +13,7 @@
 
 use comsoil_h, only: nsoilmx
+use control_mod, only: ecritphy, day_step, iphysiq
+use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
+use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
 
 implicit none
@@ -19,5 +22,5 @@
 !#include"dimphys.h"
 #include"paramet.h"
-#include"control.h"
+!#include"control.h"
 !#include"comsoil.h"
 #include"netcdf.inc"
@@ -56,4 +59,13 @@
 integer,dimension(4) :: edges,corners
 
+#ifdef CPP_PARA
+! Added to work in parallel mode
+real dx3_glop(klon_glo,nsoilmx)
+real dx3_glo(iim,jjp1,nsoilmx) ! to store a global 3D data set
+real dx2_glop(klon_glo)
+real dx2_glo(iim,jjp1)     ! to store a global 2D (surface) data set
+real px2(ngrid)
+#endif
+
 ! 1. Initialization step
 if (firstname.eq."1234567890") then
@@ -75,10 +87,12 @@
   
   ! Create output NetCDF file
-  ierr=NF_CREATE(filename,IOR(NF_CLOBBER,NF_64BIT_OFFSET),nid)
-  if (ierr.ne.NF_NOERR) then
+  if (is_master) then
+   ierr=NF_CREATE(filename,NF_CLOBBER,nid)
+   if (ierr.ne.NF_NOERR) then
     write(*,*)'writediagsoil: Error, failed creating file '//trim(filename)
     stop
-  endif
-  
+   endif
+  endif ! of if (is_master)
+
   ! Define dimensions and axis attributes
   call iniwritesoil(nid,ngrid)
@@ -89,5 +103,7 @@
 else
   ! If not an initialization call, simply open the NetCDF file
-  ierr=NF_OPEN(filename,NF_WRITE,nid)
+  if (is_master) then
+   ierr=NF_OPEN(filename,NF_WRITE,nid)
+  endif
 endif ! of if (firstname.eq."1234567890")
 
@@ -105,19 +121,21 @@
   if (name.eq.firstname) then
     ntime=ntime+1
-    date=real(zitau+1)/real(day_step)
+    date=float(zitau+1)/float(day_step)
     ! Note: day_step is known from control.h
     
-    ! Get NetCDF ID for "time"
-    ierr=NF_INQ_VARID(nid,"time",varid)
-    ! Add the current value of date to the "time" array
+    if (is_master) then
+     ! Get NetCDF ID for "time"
+     ierr=NF_INQ_VARID(nid,"time",varid)
+     ! Add the current value of date to the "time" array
 !#ifdef NC_DOUBLE
-!    ierr=NF_PUT_VARA_DOUBLE(nid,varid,ntime,1,date)
+!     ierr=NF_PUT_VARA_DOUBLE(nid,varid,ntime,1,date)
 !#else
-    ierr=NF_PUT_VARA_REAL(nid,varid,ntime,1,date)
+     ierr=NF_PUT_VARA_REAL(nid,varid,ntime,1,date)
 !#endif
-    if (ierr.ne.NF_NOERR) then
+     if (ierr.ne.NF_NOERR) then
       write(*,*)"writediagsoil: Failed writing date to time variable"
       stop 
-    endif
+     endif
+    endif ! of if (is_master)
   endif ! of if (name.eq.firstname)
 
@@ -125,4 +143,17 @@
 if (dimpx.eq.3) then ! Case of a 3D variable
   ! A. Recast data along 'dynamics' grid
+#ifdef CPP_PARA
+  ! gather field on a "global" (without redundant longitude) array
+  call Gather(px,dx3_glop)
+!$OMP MASTER
+  if (is_mpi_root) then
+    call Grid1Dto2D_glo(dx3_glop,dx3_glo)
+    ! copy dx3_glo() to dx3(:) and add redundant longitude
+    data3(1:iim,:,:)=dx3_glo(1:iim,:,:)
+    data3(iip1,:,:)=data3(1,:,:)
+  endif
+!$OMP END MASTER
+!$OMP BARRIER
+#else
   do l=1,nsoilmx
     ! handle the poles
@@ -140,6 +171,8 @@
     enddo
   enddo
+#endif
   
   ! B. Write (append) the variable to the NetCDF file
+  if (is_master) then
   ! B.1. Get the ID of the variable
   ierr=NF_INQ_VARID(nid,name,varid)
@@ -179,7 +212,23 @@
                " to file "//trim(filename)//" at time",date
   endif
+  endif ! of if (is_master)
 
 elseif (dimpx.eq.2) then ! Case of a 2D variable
+
   ! A. Recast data along 'dynamics' grid
+#ifdef CPP_PARA
+  ! gather field on a "global" (without redundant longitude) array
+  px2(:)=px(:,1)
+  call Gather(px2,dx2_glop)
+!$OMP MASTER
+  if (is_mpi_root) then
+    call Grid1Dto2D_glo(dx2_glop,dx2_glo)
+    ! copy dx3_glo() to dx3(:) and add redundant longitude
+    data2(1:iim,:)=dx2_glo(1:iim,:)
+    data2(iip1,:)=data2(1,:)
+  endif
+!$OMP END MASTER
+!$OMP BARRIER
+#else
   ! handle the poles
   do i=1,iip1
@@ -195,6 +244,8 @@
     data2(iip1,j)=data2(1,j) ! extra (modulo) longitude
   enddo
+#endif
 
   ! B. Write (append) the variable to the NetCDF file
+  if (is_master) then
   ! B.1. Get the ID of the variable
   ierr=NF_INQ_VARID(nid,name,varid)
@@ -231,6 +282,11 @@
                " to file "//trim(filename)//" at time",date
   endif
+  endif ! of if (is_master)
 
 elseif (dimpx.eq.0) then ! Case of a 0D variable
+#ifdef CPP_PARA
+  write(*,*) "writediagsoil: dimps==0 case not implemented in // mode!!"
+  stop
+#endif
   ! A. Copy data value
   data0=px(1,1)
@@ -270,5 +326,7 @@
 
 ! 4. Close the NetCDF file
-ierr=NF_CLOSE(nid)
+if (is_master) then
+  ierr=NF_CLOSE(nid)
+endif
 
 end subroutine writediagsoil
Index: trunk/LMDZ.MARS/libf/phymars/wstats.F90
===================================================================
--- trunk/LMDZ.MARS/libf/phymars/wstats.F90	(revision 1127)
+++ trunk/LMDZ.MARS/libf/phymars/wstats.F90	(revision 1130)
@@ -1,3 +1,6 @@
 subroutine wstats(ngrid,nom,titre,unite,dim,px)
+
+use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather, klon_mpi_begin
+use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
 
 implicit none
@@ -5,4 +8,5 @@
 #include "dimensions.h"
 #include "dimphys.h"
+#include "comconst.h"
 #include "statto.h"
 #include "netcdf.inc"
@@ -11,95 +15,130 @@
 character (len=*),intent(in) :: nom,titre,unite
 integer,intent(in) :: dim
-real, dimension(ngrid,llm),intent(in) :: px
 integer,parameter :: iip1=iim+1
 integer,parameter :: jjp1=jjm+1
+real,intent(in) :: px(ngrid,llm)
 real, dimension(iip1,jjp1,llm) :: mean3d,sd3d,dx3
 real, dimension(iip1,jjp1) :: mean2d,sd2d,dx2
 character (len=50) :: namebis
 character (len=50), save :: firstvar
-integer :: ierr,ierr2,varid,nbdim,nid
+integer :: ierr,varid,nbdim,nid
 integer :: meanid,sdid
-integer, dimension(4)  :: id,start,size
+integer, dimension(4)  :: id,start,sizes
 logical, save :: firstcall=.TRUE.
 integer :: l,i,j,ig0
-integer,save :: index
-! Added to use stats.def to select output variable
-logical,save :: stats_def
-logical :: getout
-integer,save :: n_nom_def
-integer :: n
-integer,parameter :: n_nom_def_max=99
-character(len=20),save :: nom_def(n_nom_def_max)
-logical, save :: notfoundfirst=.TRUE.
+integer,save :: indx
 
 integer, save :: step=0
-      
-      
-
+
+! Added to work in parallel mode
+#ifdef CPP_PARA
+real px3_glop(klon_glo,llm) ! to store a 3D data set on global physics grid
+real px3_glo(iim,jjp1,llm) ! to store a global 3D data set on global lonxlat grid
+real px2_glop(klon_glo) ! to store a 2D data set on global physics grid
+real px2_glo(iim,jjp1) ! to store a 2D data set on global lonxlat grid
+real px2(ngrid)
+real px3(ngrid,llm)
+#else
+! When not running in parallel mode:
+real px3_glop(ngrid,llm) ! to store a 3D data set on global physics grid
+real px3_glo(iim,jjp1,llm) ! to store a global 3D data set on global lonxlat grid
+real px2_glop(ngrid) ! to store a 2D data set on global physics grid
+real px2_glo(iim,jjp1) ! to store a 2D data set on global lonxlat grid
+#endif
+
+! 1. Initialization (creation of stats.nc file)
 if (firstcall) then
    firstcall=.false.
+   firstvar=trim((nom))
    call inistats(ierr)
-! at very first call, check if there is a "stats.def" to use and read it
-   open(99,file="stats.def",status='old',form='formatted',iostat=ierr2)
-   if(ierr2.eq.0) then
-     stats_def=.true.
-     write(*,*) "******************"
-     write(*,*) "Reading stats.def"
-     write(*,*) "******************"
-     do n=1,n_nom_def_max
-          read(99,fmt='(a)',end=88) nom_def(n)
-          write(*,*) 'Output in stats: ', trim(nom_def(n))
-     end do 
-88   continue
-     if (n.ge.n_nom_def_max) then
-        write(*,*)"n_nom_def_max too small in wstats.F90:",n
-        stop
-     end if 
-     n_nom_def=n-1
-     close(99)
-   else
-     firstvar=trim((nom))
-     stats_def=.false.
-     notfoundfirst=.false.
-   endif
-endif
-
-! find firstvar that is in stats.def
-if (notfoundfirst) then
-   do n=1,n_nom_def_max
-     if(trim((nom_def(n))).eq.trim((nom))) then
-        firstvar=trim((nom))
-        notfoundfirst=.false.
-     endif
-   end do 
-endif
-
-! get out of wstats if there is stats.def AND variable not listed
-if (stats_def) then
-   getout=.true.
-   do n=1,n_nom_def
-       if(trim(nom_def(n)).eq.nom) getout=.false.
-   end do
-   if (getout) return
-end if
-
-if (firstvar==nom) then ! If we're back to the first variable
+endif
+
+if (firstvar==nom) then ! If we're back to the first variable, increment time counter
       step = step + 1
 endif
 
 if (mod(step,istats).ne.0) then
+  ! if its not time to write to file, exit
    RETURN
 endif
 
+! collect fields on a global physics grid
+#ifdef CPP_PARA
+ if (dim.eq.3) then
+  px3(1:ngrid,1:llm)=px(1:ngrid,1:llm)
+  ! Gather fieds on a "global" (without redundant longitude) array
+  call Gather(px3,px3_glop)
+!$OMP MASTER
+  if (is_mpi_root) then
+    call Grid1Dto2D_glo(px3_glop,px3_glo)
+    ! copy dx3_glo() to dx3(:) and add redundant longitude
+    dx3(1:iim,:,:)=px3_glo(1:iim,:,:)
+    dx3(iip1,:,:)=dx3(1,:,:)
+  endif
+!$OMP END MASTER
+!$OMP BARRIER
+ else ! dim.eq.2
+  ! Gather fieds on a "global" (without redundant longitude) array
+  px2(:)=px(:,1)
+  call Gather(px2,px2_glop)
+!$OMP MASTER
+          if (is_mpi_root) then
+            call Grid1Dto2D_glo(px2_glop,px2_glo)
+            ! copy px2_glo() to dx2(:) and add redundant longitude
+            dx2(1:iim,:)=px2_glo(1:iim,:)
+            dx2(iip1,:)=dx2(1,:)
+          endif
+!$OMP END MASTER
+!$OMP BARRIER
+ endif
+#else
+  if (dim.eq.3) then
+    px3_glop(:,1:llm)=px(:,1:llm)
+!  Passage variable physique -->  variable dynamique
+    DO l=1,llm
+      DO i=1,iim
+         px3_glo(i,1,l)=px(1,l)
+         px3_glo(i,jjp1,l)=px(ngrid,l)
+      ENDDO
+      DO j=2,jjm
+         ig0= 1+(j-2)*iim
+         DO i=1,iim
+            px3_glo(i,j,l)=px(ig0+i,l)
+         ENDDO
+      ENDDO
+    ENDDO
+  else ! dim.eq.2
+    px2_glop(:)=px(:,1)
+!    Passage variable physique -->  physique dynamique
+   DO i=1,iim
+     px2_glo(i,1)=px(1,1)
+     px2_glo(i,jjp1)=px(ngrid,1)
+   ENDDO
+   DO j=2,jjm
+     ig0= 1+(j-2)*iim
+     DO i=1,iim
+        px2_glo(i,j)=px(ig0+i,1)
+     ENDDO
+   ENDDO
+  endif
+#endif
+
+! 2. Write field to file
+
+if (is_master) then
+! only master needs do this
+
 ierr = NF_OPEN("stats.nc",NF_WRITE,nid)
 
 namebis=trim(nom)
+
+! test: check if that variable already exists in file
 ierr= NF_INQ_VARID(nid,namebis,meanid)
 
 if (ierr.ne.NF_NOERR) then
-
+  ! variable not in file, create/define it
    if (firstvar==nom) then 
-      index=1
-      count=0
+      indx=1
+      count(:)=0
    endif
 
@@ -122,9 +161,17 @@
    write (*,*) "STATS: creation de ",nom
    namebis=trim(nom)
-   call def_var_stats(nid,namebis,titre,unite,nbdim,id,meanid,ierr)
-   call inivar(nid,meanid,ngrid,dim,index,px,ierr)
+   call def_var(nid,namebis,titre,unite,nbdim,id,meanid,ierr)
+   if (dim.eq.3) then
+     call inivar(nid,meanid,size(px3_glop,1),dim,indx,px3_glop,ierr)
+   else ! dim.eq.2
+     call inivar(nid,meanid,size(px2_glop,1),dim,indx,px2_glop,ierr)
+   endif
    namebis=trim(nom)//"_sd"
-   call def_var_stats(nid,namebis,trim(titre)//" total standard deviation over the season",unite,nbdim,id,sdid,ierr)
-   call inivar(nid,sdid,ngrid,dim,index,px,ierr)
+   call def_var(nid,namebis,trim(titre)//" total standard deviation over the season",unite,nbdim,id,sdid,ierr)
+   if (dim.eq.3) then
+     call inivar(nid,sdid,size(px3_glop,1),dim,indx,px3_glop,ierr)
+   else ! dim.eq.2
+     call inivar(nid,sdid,size(px2_glop,1),dim,indx,px2_glop,ierr)
+   endif
 
    ierr= NF_CLOSE(nid)
@@ -132,4 +179,5 @@
 
 else
+   ! variable found in file
    namebis=trim(nom)//"_sd"
    ierr= NF_INQ_VARID(nid,namebis,sdid)
@@ -138,33 +186,35 @@
 
 if (firstvar==nom) then 
-   count(index)=count(int(index))+1
-   index=index+1
-   if (index>istime) then
-      index=1
-   endif
-endif
-
-if (count(index)==0) then
+   count(indx)=count(int(indx))+1
+   indx=indx+1
+   if (indx>istime) then
+      indx=1
+   endif
+endif
+
+if (count(indx)==0) then
+   ! very first time we write the variable to file
    if (dim.eq.3) then
-      start=(/1,1,1,index/)
-      size=(/iip1,jjp1,llm,1/)
-      mean3d=0
-      sd3d=0
+      start=(/1,1,1,indx/)
+      sizes=(/iip1,jjp1,llm,1/)
+      mean3d(:,:,:)=0
+      sd3d(:,:,:)=0
    else if (dim.eq.2) then
-      start=(/1,1,index,0/)
-      size=(/iip1,jjp1,1,0/)
-      mean2d=0
-      sd2d=0
+      start=(/1,1,indx,0/)
+      sizes=(/iip1,jjp1,1,0/)
+      mean2d(:,:)=0
+      sd2d(:,:)=0
    endif
 else
+   ! load values from file
    if (dim.eq.3) then
-      start=(/1,1,1,index/)
-      size=(/iip1,jjp1,llm,1/)
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VARA_DOUBLE(nid,meanid,start,size,mean3d)
-      ierr = NF_GET_VARA_DOUBLE(nid,sdid,start,size,sd3d)
-#else
-      ierr = NF_GET_VARA_REAL(nid,meanid,start,size,mean3d)
-      ierr = NF_GET_VARA_REAL(nid,sdid,start,size,sd3d)
+      start=(/1,1,1,indx/)
+      sizes=(/iip1,jjp1,llm,1/)
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VARA_DOUBLE(nid,meanid,start,sizes,mean3d)
+      ierr = NF_GET_VARA_DOUBLE(nid,sdid,start,sizes,sd3d)
+#else
+      ierr = NF_GET_VARA_REAL(nid,meanid,start,sizes,mean3d)
+      ierr = NF_GET_VARA_REAL(nid,sdid,start,sizes,sd3d)
 #endif
       if (ierr.ne.NF_NOERR) then
@@ -174,12 +224,12 @@
 
    else if (dim.eq.2) then
-      start=(/1,1,index,0/)
-      size=(/iip1,jjp1,1,0/)
-#ifdef NC_DOUBLE
-      ierr = NF_GET_VARA_DOUBLE(nid,meanid,start,size,mean2d)
-      ierr = NF_GET_VARA_DOUBLE(nid,sdid,start,size,sd2d)
-#else
-      ierr = NF_GET_VARA_REAL(nid,meanid,start,size,mean2d)
-      ierr = NF_GET_VARA_REAL(nid,sdid,start,size,sd2d)
+      start=(/1,1,indx,0/)
+      sizes=(/iip1,jjp1,1,0/)
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VARA_DOUBLE(nid,meanid,start,sizes,mean2d)
+      ierr = NF_GET_VARA_DOUBLE(nid,sdid,start,sizes,sd2d)
+#else
+      ierr = NF_GET_VARA_REAL(nid,meanid,start,sizes,mean2d)
+      ierr = NF_GET_VARA_REAL(nid,sdid,start,sizes,sd2d)
 #endif
       if (ierr.ne.NF_NOERR) then
@@ -188,7 +238,78 @@
       endif
    endif
-endif
+endif ! of if (count(indx)==0)
+
+
+! 2.1. Build dx* (data on lon-lat grid, with redundant longitude)
 
 if (dim.eq.3) then
+  dx3(1:iim,:,:)=px3_glo(:,:,:)
+  dx3(iip1,:,:)=dx3(1,:,:)
+else ! dim.eq.2
+  dx2(1:iim,:)=px2_glo(:,:)
+  dx2(iip1,:)=dx2(1,:)
+endif
+
+
+! 2.2. Add current values to previously stored sums
+
+if (dim.eq.3) then
+
+   mean3d(:,:,:)=mean3d(:,:,:)+dx3(:,:,:)
+   sd3d(:,:,:)=sd3d(:,:,:)+dx3(:,:,:)**2
+
+#ifdef NC_DOUBLE
+   ierr = NF_PUT_VARA_DOUBLE(nid,meanid,start,sizes,mean3d)
+   ierr = NF_PUT_VARA_DOUBLE(nid,sdid,start,sizes,sd3d)
+#else
+   ierr = NF_PUT_VARA_REAL(nid,meanid,start,sizes,mean3d)
+   ierr = NF_PUT_VARA_REAL(nid,sdid,start,sizes,sd3d)
+#endif
+
+else if (dim.eq.2) then
+
+   mean2d(:,:)= mean2d(:,:)+dx2(:,:)
+   sd2d(:,:)=sd2d(:,:)+dx2(:,:)**2
+
+#ifdef NC_DOUBLE
+   ierr = NF_PUT_VARA_DOUBLE(nid,meanid,start,sizes,mean2d)
+   ierr = NF_PUT_VARA_DOUBLE(nid,sdid,start,sizes,sd2d)
+#else
+   ierr = NF_PUT_VARA_REAL(nid,meanid,start,sizes,mean2d)
+   ierr = NF_PUT_VARA_REAL(nid,sdid,start,sizes,sd2d)
+#endif
+
+endif ! of if (dim.eq.3) elseif (dim.eq.2)
+
+  ierr= NF_CLOSE(nid)
+endif ! of if (is_master)
+
+end subroutine wstats
+
+!======================================================
+subroutine inivar(nid,varid,ngrid,dim,indx,px,ierr)
+
+implicit none
+
+include "dimensions.h"
+include "dimphys.h"
+include "netcdf.inc"
+
+integer, intent(in) :: nid,varid,dim,indx,ngrid
+real, dimension(ngrid,llm), intent(in) :: px
+integer, intent(out) :: ierr
+
+integer,parameter :: iip1=iim+1
+integer,parameter :: jjp1=jjm+1
+
+integer :: l,i,j,ig0
+integer, dimension(4) :: start,sizes
+real, dimension(iip1,jjp1,llm) :: dx3
+real, dimension(iip1,jjp1) :: dx2
+
+if (dim.eq.3) then
+
+   start=(/1,1,1,indx/)
+   sizes=(/iip1,jjp1,llm,1/)
 
 !  Passage variable physique -->  variable dynamique
@@ -208,20 +329,14 @@
    ENDDO
 
-   mean3d(:,:,:)= mean3d(:,:,:)+dx3(:,:,:)
-   sd3d(:,:,:)= sd3d(:,:,:)+dx3(:,:,:)**2
-
-#ifdef NC_DOUBLE
-   ierr = NF_PUT_VARA_DOUBLE(nid,meanid,start,size,mean3d)
-   ierr = NF_PUT_VARA_DOUBLE(nid,sdid,start,size,sd3d)
-#else
-   ierr = NF_PUT_VARA_REAL(nid,meanid,start,size,mean3d)
-   ierr = NF_PUT_VARA_REAL(nid,sdid,start,size,sd3d)
-#endif
-   if (ierr.ne.NF_NOERR) then
-     write (*,*) NF_STRERROR(ierr)
-     stop ""
-   endif
+#ifdef NC_DOUBLE
+   ierr = NF_PUT_VARA_DOUBLE(nid,varid,start,sizes,dx3)
+#else
+   ierr = NF_PUT_VARA_REAL(nid,varid,start,sizes,dx3)
+#endif
 
 else if (dim.eq.2) then
+
+      start=(/1,1,indx,0/)
+      sizes=(/iip1,jjp1,1,0/)
 
 !    Passage variable physique -->  physique dynamique
@@ -239,96 +354,8 @@
   ENDDO
 
-   mean2d(:,:)= mean2d(:,:)+dx2(:,:)
-   sd2d(:,:)= sd2d(:,:)+dx2(:,:)**2
-
-#ifdef NC_DOUBLE
-   ierr = NF_PUT_VARA_DOUBLE(nid,meanid,start,size,mean2d)
-   ierr = NF_PUT_VARA_DOUBLE(nid,sdid,start,size,sd2d)
-#else
-   ierr = NF_PUT_VARA_REAL(nid,meanid,start,size,mean2d)
-   ierr = NF_PUT_VARA_REAL(nid,sdid,start,size,sd2d)
-#endif
-   if (ierr.ne.NF_NOERR) then
-     write (*,*) NF_STRERROR(ierr)
-     stop ""
-   endif
-
-endif
-
-ierr= NF_CLOSE(nid)
-
-end subroutine wstats
-
-!======================================================
-subroutine inivar(nid,varid,ngrid,dim,index,px,ierr)
-
-implicit none
-
-include "dimensions.h"
-include "dimphys.h"
-include "netcdf.inc"
-
-integer, intent(in) :: nid,varid,dim,index,ngrid
-real, dimension(ngrid,llm), intent(in) :: px
-integer, intent(out) :: ierr
-
-integer,parameter :: iip1=iim+1
-integer,parameter :: jjp1=jjm+1
-
-integer :: l,i,j,ig0
-integer, dimension(4) :: start,size
-real, dimension(iip1,jjp1,llm) :: dx3
-real, dimension(iip1,jjp1) :: dx2
-
-if (dim.eq.3) then
-
-   start=(/1,1,1,index/)
-   size=(/iip1,jjp1,llm,1/)
-
-!  Passage variable physique -->  variable dynamique
-
-   DO l=1,llm
-      DO i=1,iip1
-         dx3(i,1,l)=px(1,l)
-         dx3(i,jjp1,l)=px(ngrid,l)
-      ENDDO
-      DO j=2,jjm
-         ig0= 1+(j-2)*iim
-         DO i=1,iim
-            dx3(i,j,l)=px(ig0+i,l)
-         ENDDO
-         dx3(iip1,j,l)=dx3(1,j,l)
-      ENDDO
-   ENDDO
-
-#ifdef NC_DOUBLE
-   ierr = NF_PUT_VARA_DOUBLE(nid,varid,start,size,dx3)
-#else
-   ierr = NF_PUT_VARA_REAL(nid,varid,start,size,dx3)
-#endif
-
-else if (dim.eq.2) then
-
-      start=(/1,1,index,0/)
-      size=(/iip1,jjp1,1,0/)
-
-!    Passage variable physique -->  physique dynamique
-
-  DO i=1,iip1
-     dx2(i,1)=px(1,1)
-     dx2(i,jjp1)=px(ngrid,1)
-  ENDDO
-  DO j=2,jjm
-     ig0= 1+(j-2)*iim
-     DO i=1,iim
-        dx2(i,j)=px(ig0+i,1)
-     ENDDO
-     dx2(iip1,j)=dx2(1,j)
-  ENDDO
-
-#ifdef NC_DOUBLE
-   ierr = NF_PUT_VARA_DOUBLE(nid,varid,start,size,dx2)
-#else
-   ierr = NF_PUT_VARA_REAL(nid,varid,start,size,dx2)
+#ifdef NC_DOUBLE
+   ierr = NF_PUT_VARA_DOUBLE(nid,varid,start,sizes,dx2)
+#else
+   ierr = NF_PUT_VARA_REAL(nid,varid,start,sizes,dx2)
 #endif
 
